# Plugins

{% hint style="success" %}
This is the official documentation of the `forestadmin/laravel-forestadmin` v2+ and `forestadmin/symfony-forestadmin` PHP agents.
{% endhint %}

When customizing your Agent behavior, it is quite common to have to perform the same tasks on multiple Fields and Collections.

Plugins are the answer to that need, and you are strongly encouraged to use them everywhere you notice that your customization files could benefit from code factorization.

### Minimal example

#### Using plugins

Plugins are used by either importing a module, or installing the relevant package, and then calling the `use` method.

Depending on the plugin, options may be provided.

```php
<?php

use ForestAdmin\AgentPHP\Agent\Utils\Env;
use ForestAdmin\AgentPHP\DatasourceCustomizer\CollectionCustomizer;
use ForestAdmin\AgentPHP\DatasourceDoctrine\DoctrineDatasource;
use ForestAdmin\SymfonyForestAdmin\Service\ForestAgent;
use MyNamespace\Plugins\CreateFileField;
use MyNamespace\Plugins\RemoveTimestamps;

// The use() method can be called both on the agent and on collections
return static function (ForestAgent $forestAgent) {

    $forestAgent->addDatasource(
        new DoctrineDatasource($forestAgent->getEntityManager(), [
                'url'      => Env::get('DATABASE_URL'),
            ]),
        )

        // Some plugins do not require options
        ->use(RemoveTimestamps::class)

        // Others do
        ->customizeCollection(
            'Book',
            fn (CollectionCustomizer $builder) => $builder->use(
                CreateFileField::class,
                ['fieldname': 'avatar']
            )
        )
```

#### Writing plugins

A plugin is nothing more than a `class` that implements our `Plugin interface` and can perform customizations.

The full documentation can be found in the ["Write your own plugin" section](/developer-guide-agents-php/agent-customization/plugins/custom.md).

```php
<?php

namespace ...;

use ForestAdmin\AgentPHP\DatasourceCustomizer\CollectionCustomizer;
use ForestAdmin\AgentPHP\DatasourceCustomizer\DatasourceCustomizer;

class RemoveTimestamps implements Plugin
{
    public function run(DatasourceCustomizer $datasourceCustomizer, ?CollectionCustomizer $collectionCustomizer = null, $options = []): void
    {
        // Allow the plugin to be used both on the dataSource or on individual collections
        $collections = $collectionCustomizer ? [$collectionCustomizer] : $datasourceCustomizer->getCollections();

        // Remove fields
        foreach ($datasourceCustomizer->getCollection() as $currentCollection) {
            $currentCollection->removeField('createdAt');
            $currentCollection->removeField('updatedAt');
        }
    }
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.forestadmin.com/developer-guide-agents-php/agent-customization/plugins.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
